USE [AdventureWorks2012]
GO

SET STATISTICS IO ON
SET NOCOUNT ON
GO

/* Clear plans and data pages from memory to get cold start */
CHECKPOINT;
DBCC DROPCLEANBUFFERS;
DBCC FREEPROCCACHE;

/*************************** Table variable *********************************************/
DECLARE @Carriers TABLE
(
	CarrierTrackingNumber NVARCHAR(25) PRIMARY KEY CLUSTERED
)
INSERT INTO @Carriers(CarrierTrackingNumber)
SELECT DISTINCT TOP 1000 CarrierTrackingNumber
FROM Sales.SalesOrderDetailEnlarged 
WHERE CarrierTrackingNumber IS NOT NULL

SELECT d.CarrierTrackingNumber 
FROM Sales.SalesOrderDetailEnlarged d
JOIN @Carriers c ON d.CarrierTrackingNumber = c.CarrierTrackingNumber 
WHERE d.ProductID = 776
GO

/************************ Table Variable Option Recompile ******************************/
DECLARE @Carriers TABLE
(
	CarrierTrackingNumber NVARCHAR(25) PRIMARY KEY CLUSTERED
)
INSERT INTO @Carriers(CarrierTrackingNumber)
SELECT DISTINCT TOP 1000 CarrierTrackingNumber
FROM Sales.SalesOrderDetail
WHERE CarrierTrackingNumber IS NOT NULL

SELECT d.CarrierTrackingNumber 
FROM Sales.SalesOrderDetailEnlarged d
JOIN @Carriers c ON d.CarrierTrackingNumber = c.CarrierTrackingNumber 
WHERE d.ProductID = 776
OPTION(RECOMPILE);

/********************Temp Table Example ************************************************/
IF OBJECT_ID('tempdb..#Carriers') IS NOT NULL
DROP TABLE #Carriers
GO
CREATE TABLE #Carriers(CarrierTrackingNumber NVARCHAR(25) PRIMARY KEY CLUSTERED)

INSERT INTO #Carriers(CarrierTrackingNumber)
SELECT DISTINCT TOP 1000 CarrierTrackingNumber
FROM Sales.SalesOrderDetail 
WHERE CarrierTrackingNumber IS NOT NULL

SELECT d.CarrierTrackingNumber 
FROM Sales.SalesOrderDetail d
JOIN #Carriers c ON d.CarrierTrackingNumber = c.CarrierTrackingNumber 
WHERE d.ProductID = 776

GO